﻿package 
{
	import com.greensock.easing.*;
	import com.greensock.TweenLite;
	import com.selenetan.ludumdare16.*
	import flash.display.BlendMode;
	import flash.media.Sound;
	import flash.media.SoundChannel;
	import flash.text.TextField;
	import flash.text.TextFormat;
	
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.BitmapDataChannel;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.filters.GlowFilter
	
	/**
	 * ...
	 * @author Selene
	 */
	public class Main extends Sprite 
	{
		private var fog:Fog;
		
		// Sprites
		private var bg:Sprite;			// Gives us something to click on
		private var player:Sprite;
		private var exit:ExitPortal;
		
		private var shooter:Shooter;
		
		private var level:Level;
		
		private var hintLayer:HintLayer;
		
		private var menuLayer:MenuScreen;
		
		private var muteBtn:Sprite;
		private var soundManager:SoundManager;
		
		public function Main():void 
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			// entry point
			
			new Resources();
			
			createMenuLayer();
			
			// Make quick visuals for the sprites
			bg = new Sprite();
			bg.graphics.beginFill(0x000000);
			bg.graphics.drawRect(0, 0, Settings.GAME_WIDTH, Settings.GAME_HEIGHT);
			addChild(bg);
			
			exit = new ExitPortal();
						
			drawPlayer();
			
			hintLayer = new HintLayer();
			
			// Set up the bitmaps
			fog = new Fog(Settings.GAME_WIDTH, Settings.GAME_HEIGHT, 0xFF333333);
			//fog.alpha = 0.5;	// **DEBUG

			// Sound! (SoundManager starts muted by default)
			soundManager = new SoundManager();
			muteBtn = soundManager.muteButton;
			
			shooter = new Shooter(this, player, soundManager);
			level = new Level(this, player, exit, fog, hintLayer, shooter, menuLayer, soundManager);
			shooter.init();
			shooter.setLevel(level);
			
			
			addChild(menuLayer);
			addChild(muteBtn);
		}
		
		
		private function createMenuLayer():void
		{
			menuLayer = new MenuScreen();
		}
		
		private function drawPlayer():void
		{
			player = new Sprite();
			player.graphics.lineStyle(2, 0x00FF00, 0.8, true);
			player.graphics.moveTo( -15, -10);
			player.graphics.lineTo( -15, -15);
			player.graphics.lineTo( -10, -15);
			player.graphics.moveTo(10, -15);
			player.graphics.lineTo(15, -15);
			player.graphics.lineTo(15, -10);
			player.graphics.moveTo(15, 10);
			player.graphics.lineTo(15, 15);
			player.graphics.lineTo(10, 15);
			player.graphics.moveTo(-15, 10);
			player.graphics.lineTo(-15, 15);
			player.graphics.lineTo(-10, 15);
			player.filters = [new GlowFilter(0x00FF00, 0.6)];
			
			player.name = "Sprite Player";
			player.mouseEnabled = false;
		}		
	}
	
}