﻿package com.selenetan.ludumdare16 
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.BitmapDataChannel;
	import flash.display.Shape;
	import flash.filters.BlurFilter;
	
	import flash.geom.Rectangle;
	import flash.geom.Point;
	
	/**
	 * ...
	 * @author Selene
	 */
	public class Fog extends Bitmap
	{
		
		private var scratch:Bitmap;
		private var fogColor:uint;
		
		public function Fog(width:Number=800, height:Number=600, color:uint=0xFF111111) 
		{
			var bmpData:BitmapData = new BitmapData(width, height, true, color);
			super(bmpData, "auto", true);
			
			bmpData = new BitmapData(width, height, false, 0xFFFFFF);
			scratch = new Bitmap(bmpData, "auto", true);
			
			fogColor = color;
		}
		
		public function revealCircle(x:Number, y:Number, radius:Number):void
		{
			var drawShape:Shape = new Shape();
			drawShape.graphics.beginFill(0x00FFFF);
			drawShape.graphics.drawCircle(x, y, radius);
			drawShape.filters = [new BlurFilter(4, 4)];
			
			scratch.bitmapData.draw(drawShape);
			bitmapData.copyChannel(scratch.bitmapData, new Rectangle(0, 0, width, height), new Point(0, 0), BitmapDataChannel.RED, BitmapDataChannel.ALPHA);
		}
		
		
		public function reset():void
		{
			trace("Reset fog!");
			
			var bmpData:BitmapData = new BitmapData(width, height, true, fogColor);
			bitmapData = bmpData;
			
			bmpData = new BitmapData(width, height, false, 0xFFFFFF);
			scratch.bitmapData = bmpData;			
		}
		
	}

}