﻿package com.selenetan.ludumdare16 
{
	import com.greensock.TweenLite;
	import com.greensock.easing.Quad;
	import flash.display.BlendMode;
	import flash.filters.GlowFilter;
	
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.events.TimerEvent;
	import flash.utils.Timer;
	
	/**
	 * ...
	 * @author Selene
	 */
	public class HintLayer extends Sprite
	{
		private var hints:Bitmap;
		private var currHint:Sprite;

		private var dimmer:Shape;
		private var dimTimer:Timer;
		
		
		public function HintLayer() 
		{
			var bmpData:BitmapData = new BitmapData(Settings.GAME_WIDTH, Settings.GAME_HEIGHT, true, 0x000000);
			hints = new Bitmap(bmpData, "auto", true);
			hints.blendMode = BlendMode.SCREEN;
			
			currHint = new Sprite();
			currHint.visible = false;
			currHint.name = "Sprite currHint";
			
			dimmer = new Shape();
			dimmer.graphics.beginFill(0x000000, 0.08);
			dimmer.graphics.drawRect(0, 0, Settings.GAME_WIDTH, Settings.GAME_HEIGHT);
			
			dimTimer = new Timer(Settings.DIM_INTERVAL);
			dimTimer.addEventListener(TimerEvent.TIMER, dimHints);
			dimTimer.start();
			
			addChild(hints);
			addChild(currHint);

			mouseEnabled = false;
		}
		
		
		public function showHint(x:Number, y:Number, distance:Number):void
		{
			currHint.graphics.clear();
			currHint.graphics.lineStyle(2, 0xFFFFFF);
			currHint.graphics.drawCircle(0, 0, distance);
			currHint.x = x;
			currHint.y = y;
			currHint.filters = [new GlowFilter(0xFFFFFF, 0.6)];


			currHint.visible = true;
			currHint.alpha = 0;
			TweenLite.to(currHint, 0.8, { alpha: 0.5, ease: Quad.easeIn, onComplete: recordHint, onCompleteParams: [x, y, distance] } );
		}
		
		private function recordHint(x:Number, y:Number, distance:Number):void
		{
			currHint.alpha = 0;			
			currHint.graphics.clear();
			currHint.graphics.lineStyle(2, 0xFFFFFF);
			currHint.graphics.drawCircle(x, y, distance);
			currHint.filters = [new GlowFilter(0xFFFFFF, 0.6)];
			
			hints.bitmapData.draw(currHint);
		}
		
		private function dimHints(evt:TimerEvent):void
		{
			hints.bitmapData.draw(dimmer);
		}
		
		public function reset():void
		{
			var bmpData:BitmapData = new BitmapData(Settings.GAME_WIDTH, Settings.GAME_HEIGHT, true, 0x000000);
			hints.bitmapData = bmpData;
			hints.smoothing = true;
		}
		
	}

}