﻿package com.selenetan.ludumdare16 
{
	import com.greensock.TweenLite;
	import flash.display.Shape;
	import flash.display.SimpleButton;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.filters.GlowFilter;
	import flash.net.navigateToURL;
	import flash.net.URLRequest;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFormat;
	import flash.text.TextFormatAlign;
	
	
	/**
	 * ...
	 * @author Selene
	 */
	public class MenuScreen extends Sprite
	{
		private var titleField:TextField;
		
		private var scoreField:TextField;
		private var scoreFormat:TextFormat;
		
		private var startButton:Sprite;
		private var buttonTextFormat:TextFormat;
		
		private var helpButton:Sprite;
		private var helpScreen:Sprite;
		private var closeHelpButton:Sprite;
		
		private var creditButton:Sprite;
		private var creditField:TextField;
		
		private var menubg:Sprite;
		
		private var buttonGlow:GlowFilter;
		private var buttonHighlight:GlowFilter;
		
		public function MenuScreen() 
		{
			menubg = new Sprite();
			menubg.graphics.beginFill(0x000000, 1);
			menubg.graphics.drawRect(0, 0, Settings.GAME_WIDTH, Settings.GAME_HEIGHT);
			menubg.useHandCursor = false;
			menubg.name = "Sprite MenuBG";
			
			buttonTextFormat = new TextFormat("mainFont", 36, 0xFFFFFF, true);
			buttonTextFormat.align = TextFormatAlign.CENTER;
	
			scoreField = new TextField();
			
			buttonGlow = new GlowFilter(0xFFFFFF, 0.4, 4, 4);
			buttonHighlight = new GlowFilter(0xFFFFFF, 0.4, 8, 8, 3);
			
			addChild(menubg);
			
			createCreditButton();
			createStartButton();
			createHelpButton();
			createTitle();
			createScoreField();
			
			createHelpScreen();

			activate();
		}
		
		private function createCreditButton():void
		{
			creditButton = new Sprite();
			
			creditField = new TextField();
			var creditFormat:TextFormat = new TextFormat("mainFont", 12, 0xFFFFFF);
			creditField.defaultTextFormat = creditFormat;
			creditField.embedFonts = true;
			creditField.selectable = false;
			creditField.text = "© 2009 Selene Tan";
			creditField.autoSize = TextFieldAutoSize.CENTER;
			
			creditButton.filters = [buttonGlow];
			
			creditButton.addChild(creditField);
			creditButton.x = 10;
			creditButton.y = 10;
			
			creditButton.addEventListener(MouseEvent.MOUSE_OVER, highlightButton);
			creditButton.addEventListener(MouseEvent.MOUSE_OUT, unhighlightButton);
			creditButton.addEventListener(MouseEvent.MOUSE_DOWN, openWebsite);
			
			addChild(creditButton);
		}
		
		private function createTitle():void
		{
			var fmt:TextFormat = new TextFormat("mainFont", 64, 0x00FF00);
			fmt.align = TextFormatAlign.CENTER;
			
			titleField = new TextField();
			titleField.selectable = false;
			titleField.mouseEnabled = false;
			titleField.defaultTextFormat = fmt;
			titleField.text = Settings.GAME_TITLE;
			titleField.setTextFormat(fmt);
			titleField.embedFonts = true;
			titleField.autoSize = TextFieldAutoSize.CENTER;
			trace("titleField width: " + titleField.width);
			
			titleField.x = Settings.GAME_WIDTH / 2.0 - titleField.width / 2.0;
			titleField.y = 100;
			
			titleField.filters = [new GlowFilter(0x00FF00, 0.4, 5, 5)];
			addChild(titleField);
		}
		
		
		private function createStartButton():void
		{
			startButton = new Sprite();
			var tf:TextField = new TextField();
			tf.text = "NEW GAME";
			tf.embedFonts = true;
			tf.selectable = false;
			tf.setTextFormat(buttonTextFormat);
			tf.autoSize = TextFieldAutoSize.CENTER;
			
			startButton.addChild(tf);
			tf.x = Settings.GAME_WIDTH / 2.0 - tf.textWidth / 2.0;
			tf.y = 360;
			
			startButton.filters = [buttonGlow];
			
			addChild(startButton);
		}
		
		private function createScoreField():void
		{
			scoreFormat = new TextFormat("mainFont", 24, 0xFFFFFF, false);
			scoreFormat.align = TextFormatAlign.CENTER;
			
			scoreField = new TextField();
			scoreField.embedFonts = true;
			scoreField.selectable = false;
			scoreField.mouseEnabled = false;
			scoreField.text = "YOUR SCORE";
			scoreField.autoSize = TextFieldAutoSize.CENTER;
			scoreField.defaultTextFormat = scoreFormat;
			scoreField.setTextFormat(scoreFormat);
			scoreField.filters = [new GlowFilter(0xFFFFFF, 0.3, 2, 2)];
			
			scoreField.x = (Settings.GAME_WIDTH - scoreField.width) / 2.0;
			scoreField.y = 250;
			scoreField.visible = false;
			addChild(scoreField);
		}
		
		
		private function createHelpButton():void
		{
			helpButton = new Sprite();
			var tf:TextField = new TextField();
			tf.text = "INSTRUCTIONS";
			tf.embedFonts = true;
			tf.selectable = false;
			tf.setTextFormat(buttonTextFormat);
			tf.autoSize = TextFieldAutoSize.CENTER;
			
			helpButton.addChild(tf);
			tf.x = Settings.GAME_WIDTH /2.0 - tf.textWidth / 2.0;
			tf.y = 410;
			
			helpButton.filters = [buttonGlow];
			
			addChild(helpButton);
		}
		
		private function createHelpScreen():void
		{
			helpScreen = new Sprite();
			
			helpScreen.graphics.beginFill(0x000000, 1);
			helpScreen.graphics.lineStyle(1, 0x00FF00);
			helpScreen.graphics.drawRect(0, 0, Settings.GAME_WIDTH * 0.8, Settings.GAME_HEIGHT * 0.8);
			//helpScreen.filters = [new GlowFilter(0x00FF00)];
			
			var helpFormat:TextFormat = new TextFormat("helpFont", 18, 0xFFFFFF, true);
			var helpField:TextField = new TextField();
			var helpText:String = "HOW TO PLAY\n\n";
			helpText += "Your goal is to find the red enemy square. Click the enemy to win the level.\n\n";
			helpText += "Explore the level by shooting flares. Move the mouse to aim. Click and hold to charge up your shot. Release the mouse to fire.\n\n";
			helpText += "If you find a yellow ally turret, you can switch to it by clicking on it. Switch turrets to change where your shots are fired from.\n\n";
			helpText += "If you don't find anything, a hint will show the distance to the nearest turret. Shoot multiple flares quickly to narrow down the location.\n\n";
			helpText += "The game ends when you run out of flares. Earn more flares by finding turrets.\n\n";
			
			helpField.text = helpText;
			helpField.setTextFormat(helpFormat);
			helpField.defaultTextFormat = helpFormat;
			helpField.multiline = true;
			helpField.wordWrap = true;
			helpField.embedFonts = true;
			helpField.selectable = false;
			helpField.width = helpScreen.width * 0.8;
			helpField.height = helpScreen.height * 0.8;
			helpField.x = helpScreen.width * 0.1;
			helpField.y = helpScreen.height * 0.1;
			
			helpScreen.addChild(helpField);
			helpScreen.x = Settings.GAME_WIDTH * 0.1;
			helpScreen.y = Settings.GAME_HEIGHT * 0.1;
			
			createCloseHelpButton();
			
			addChild(helpScreen);
			helpScreen.visible = false;
		}
		
		private function createCloseHelpButton():void
		{
			closeHelpButton = new Sprite();
			
			var tf:TextField = new TextField();
			tf.text = "X";
			tf.embedFonts = true;
			tf.selectable = false;
			tf.setTextFormat(buttonTextFormat);
			tf.autoSize = TextFieldAutoSize.CENTER;
			
			closeHelpButton.addChild(tf);
			closeHelpButton.filters = [buttonGlow];
			
			helpScreen.addChild(closeHelpButton);
			closeHelpButton.x = helpScreen.width * 0.85;
			closeHelpButton.y = 20;
		}
		
		public function showStart():void
		{
			titleField.text = Settings.GAME_TITLE;
			titleField.autoSize = TextFieldAutoSize.CENTER;
			
			titleField.x = Settings.GAME_WIDTH / 2.0 - titleField.width / 2.0;
			
			TweenLite.to(this, 1.3, { alpha: 1, visible: true } );
			activate();
		}
		
		public function showGameOver(score:Number):void
		{
			TweenLite.to(this, 1.3, { alpha: 1, visible: true } );
			
			titleField.text = "GAME OVER";
			titleField.autoSize = TextFieldAutoSize.CENTER;
			
			titleField.x = Settings.GAME_WIDTH / 2.0 - titleField.width / 2.0;
			
			
			scoreField.text = "YOUR SCORE\n" + score;
			scoreField.visible = true;
			
			activate();
		}
		
		public function hide():void
		{
			deactivate();
			TweenLite.to(this, 1.3, { alpha: 0, visible:false } );
		}
		
		
		private function activate():void
		{
			trace("MenuScreen.activate()");
			startButton.addEventListener(MouseEvent.MOUSE_OVER, highlightButton);
			startButton.addEventListener(MouseEvent.MOUSE_OUT, unhighlightButton);
			startButton.addEventListener(MouseEvent.MOUSE_DOWN, clickStartButton);
			
			helpButton.addEventListener(MouseEvent.MOUSE_OVER, highlightButton);
			helpButton.addEventListener(MouseEvent.MOUSE_OUT, unhighlightButton);
			helpButton.addEventListener(MouseEvent.MOUSE_DOWN, showHelp);
			
			menubg.addEventListener(MouseEvent.MOUSE_DOWN, nullListener);
			menubg.visible = true;
			mouseEnabled = true;
			mouseChildren = true;
		}
		
		private function deactivate():void
		{
			trace("MenuScreen.deactivate");
			startButton.removeEventListener(MouseEvent.MOUSE_OVER, highlightButton);
			startButton.removeEventListener(MouseEvent.MOUSE_OUT, unhighlightButton);
			startButton.removeEventListener(MouseEvent.MOUSE_DOWN, clickStartButton);

			helpButton.removeEventListener(MouseEvent.MOUSE_OVER, highlightButton);
			helpButton.removeEventListener(MouseEvent.MOUSE_OUT, unhighlightButton);
			helpButton.removeEventListener(MouseEvent.MOUSE_DOWN, showHelp);

			menubg.removeEventListener(MouseEvent.MOUSE_DOWN, nullListener);
			menubg.visible = false;
			mouseEnabled = false;
			mouseChildren = false;
		}
		

		
		private function highlightButton(evt:Event = null):void
		{
			if (evt)
			{
				evt.currentTarget.filters = [buttonHighlight];
			}
		}
		
		private function unhighlightButton(evt:Event = null):void
		{
			if (evt)
			{
				evt.currentTarget.filters = [buttonGlow];
			}
		}
		
		private function clickStartButton(evt:Event = null):void
		{
			if (evt) evt.stopPropagation();
			unhighlightButton(evt);
			dispatchEvent(new Event("startGame"));
			hide();
		}
		
		
		private function showHelp(evt:Event):void
		{
			if (evt) evt.stopPropagation();
			
			helpScreen.visible = true;
			helpScreen.alpha = 0;
			TweenLite.to(helpScreen, 0.9, { alpha: 1 } );
			
			closeHelpButton.addEventListener(MouseEvent.MOUSE_OVER, highlightButton);
			closeHelpButton.addEventListener(MouseEvent.MOUSE_OUT, unhighlightButton);
			closeHelpButton.addEventListener(MouseEvent.MOUSE_DOWN, hideHelp);
		}
		
		private function hideHelp(evt:Event):void
		{
			if (evt) evt.stopPropagation();
			
			TweenLite.to(helpScreen, 0.9, { alpha: 0, onComplete: function ():void { helpScreen.visible = false;} } );
			
			closeHelpButton.removeEventListener(MouseEvent.MOUSE_OVER, highlightButton);
			closeHelpButton.removeEventListener(MouseEvent.MOUSE_OUT, unhighlightButton);
			closeHelpButton.removeEventListener(MouseEvent.MOUSE_DOWN, hideHelp);
		}
		
		private function openWebsite(evt:Event):void
		{
			navigateToURL(new URLRequest("http://selenetan.com"));
		}
		
		private function nullListener(evt:Event = null):void
		{
			trace("MenuScreen.nullListener");
			if (evt) evt.stopPropagation();
		}
	}

}