﻿package com.selenetan.ludumdare16
{
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	
	import flash.display.GradientType;
	import flash.filters.GlowFilter;
	
	import com.greensock.TweenLite;
	
	/**
	 * ...
	 * @author Selene
	 */
	public class WarpPortal extends Sprite
	{
		private var hidden:Boolean;
		protected var hitSprite:Shape;
		private var gunShape:Shape;
		
		protected static var numPortals:int = 0;
		private var id:int;
		
		public function WarpPortal($x:Number=0, $y:Number=0) 
		{
			
			hitSprite = new Shape();
			hitSprite.graphics.beginFill(0x000000, 0.1);
			hitSprite.graphics.drawRect( -14, -14, 28, 28);
			addChild(hitSprite);
			
			// The gun...
			gunShape = new Shape();
			gunShape.graphics.lineStyle(2, 0xFFFF000, 0.8, true);
			gunShape.graphics.moveTo(0, 3);
			gunShape.graphics.lineTo(30, 3);
			gunShape.graphics.lineTo(30, -3);
			gunShape.graphics.lineTo(0, -3);
			addChild(gunShape);
			
			
			// Draw it!
			graphics.lineStyle(2, 0xFFFF00, 0.8, true);
			graphics.drawRect( -15, -15, 30, 30);
			graphics.drawCircle(0, 0, 10);
			rotation = 45;
			
			
			// GlowFilter(color:uint = 0xFF0000, alpha:Number = 1.0, blurX:Number = 6.0, blurY:Number = 6.0, 
			//            strength:Number = 2, quality:int = 1, inner:Boolean = false, knockout:Boolean = false)
			filters = [new GlowFilter(0xFFFF00, 0.6, 6, 6, 2, 1)];
			
			x = $x;
			y = $y;
			
			alpha = 0.3;
			
			hidden = true;
			revealed = false;
			
			id = WarpPortal.numPortals;
			++WarpPortal.numPortals;
		}
		
		public function showGun():void
		{
			gunShape.visible = true;
		}
		
		public function hideGun():void
		{
			gunShape.visible = false;
		}
		
		
		public function get revealed():Boolean
		{
			return !hidden;
		}
		
		public function set revealed(val:Boolean):void
		{
			if (val && hidden)               
			{
				TweenLite.to(this, 1.3, { alpha: 1 } );
			}
			else if (!val && !hidden)
			{
				TweenLite.to(this, 1.3, { alpha: 0.3 } );
			}

			hidden = !val;
			
		}
		
		override public function toString():String 
		{
			return "[WarpPortal #" + id + "]";
		}
		
	}

}